/* Definitions used by VT implementation. */
/* $Header: vtimpl.h,v 1.4 88/06/03 14:44:40 guido Exp $ */

#include "configure.h"
#ifdef LSC
#define STATIC		/**/
#define NOARGS		(void)
#define ARGS(arglist)	arglist
#include <proto.h>
void dprintf ARGS((char *fmt, ...));
#else
#define STATIC		static
#endif

#include "tools.h"
#include "stdwin.h"
#include "vt.h"

/* Debug code */

#ifdef DEBUG
 /* Let it be heard that a command was not recognized */
#define FAIL() wfleep()
#else
/* Silently ignore unrecognized commands */
#define FAIL() 0
#endif

/* Names for control characters */

#define ESC	'\033'
#define CR	'\r'
#define LF	'\012'	/* Can't use \n or EOL because of MPW on Macintosh */
#define BS	'\b'
#define BEL	'\007'
#define TAB	'\t'
#define FF	'\014'

/* Macro to check for non-control character */

#define PRINTABLE(c)	!iscntrl((c) & 0xff)
			/* This must evaluate c exactly once.
			   LSC's isprint evaluates c twice!!! */

/* Functions used internally */

void vtcirculate ARGS((VT *vt, int r1, int r2, int n));
void vtchange ARGS((VT *vt, int r1, int c1, int r2, int c2));
void vtshow ARGS((VT *vt, int r1, int c1, int r2, int c2));
void vtscroll ARGS((VT *vt, int r1, int c1, int r2, int c2, int dr, int dc));
void vtsync ARGS((VT *vt));
